---
title: lang
slug: Web/HTML/Global_attributes/lang
tags:
  - Global attributes
  - HTML
  - Reference
---
<div>{{HTMLSidebar("Global_attributes")}}</div>

<p>The <strong><code>lang</code></strong> <a href="/en-US/docs/Web/HTML/Global_attributes">global attribute</a> helps define the language of an element: the language that non-editable elements are written in, or the language that the editable elements should be written in by the user. The attribute contains a single “language tag” in the format defined in <a class="external" href="https://www.ietf.org/rfc/bcp/bcp47.txt"><em>Tags for Identifying Languages (BCP47)</em></a>.</p>

<p class="note">The default value of <code>lang</code> is <code>unknown</code>, therefore it is recommended to always specify this attribute with the appropriate value.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/attribute-lang.html","tabbed-shorter")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</p>

<p>If the attribute value is the <em>empty string</em> (<code>lang=""</code>), the language is set to <em>unknown</em>; if the language tag is not valid according to BCP47, it is set to <em>invalid</em>.</p>

<div class="note">
<h2 id="Language_tag_syntax">Language tag syntax</h2>

<p>The full BCP47 syntax is in-depth enough to mark extremely specific language dialects, but most usage is much simpler.</p>

<p>A language tag is made of hyphen-separated <em>language subtags</em>, where each subtag indicates a certain property of the language. The 3 most common subtags are:</p>

<dl>
 <dt>Language subtag</dt>
 <dd>Required. A 2-or-3-character code that defines the basic language, typically written in all lowercase. For example, the language code for English is <code>en</code>, and the code for Badeshi is <code>bdz</code>.</dd>
 <dt>Script subtag</dt>
 <dd>Optional. This subtag defines the writing system used for the language, and is always 4 characters long, with the first letter capitalized. For example, French-in-Braille is <code>fr-Brai</code> and <code>ja-Kana</code> is Japanese written with the Katakana alphabet. If the language is written in a highly typical way, like English in the Latin alphabet, there is no need to use this subtag.</dd>
 <dt>Region subtag</dt>
 <dd>Optional. This subtag defines a dialect of the base language from a particular location, and is either 2 letters in ALLCAPS matching a country code, or 3 numbers matching a non-country area. For example, <code>es-ES</code> is for Spanish as spoken in Spain, and <code>es-013</code> is Spanish as spoken in Central America. “International Spanish” would just be <code>es</code>.</dd>
</dl>

<p>The script subtag precedes the region subtag if both are present — <code>ru-Cyrl-BY</code> is Russian, written in the Cyrillic alphabet, as spoken in Belarus.</p>

<p>To find the correct subtag codes for a language, try <a href="https://r12a.github.io/app-subtags/" rel="external">the Language Subtag Lookup</a>.</p>
</div>

<p>Even if the <strong>lang</strong> attribute is set, it may not be taken into account, as the <a href="/en-US/docs/Web/HTML/Global_attributes/xml:lang"><strong>xml:lang</strong></a> attribute has priority.</p>

<p>For the CSS pseudo-class {{cssxref(":lang")}}, two invalid language names are different if their names are different. So while <code>:lang(es)</code> matches both <code>lang="es-ES"</code> and <code>lang="es-419"</code>, <code>:lang(xyzzy)</code> would <em>not</em> match <code>lang="xyzzy-Zorp!"</code>.</p>

<h2 id="Accessibility">Accessibility</h2>

<p>WCAG Success Criterion 3.1.1 <strong>requires</strong> that a page language is specified in a way which may be 'programmatically determined' (i.e. via the <strong><code>lang</code></strong> attribute).</p>

<p>WCAG Sucesss criterion 3.1.2 requires that pages with <strong>parts</strong> in different languages have the languages of those parts specified too. Again, the <strong><code>lang</code></strong> attribute is the correct mechanism for this.</p>

<p>The purpose of these requirements is primarily to allow assistive technologies such as screen readers to invoke the correct pronunciation.</p>

<p>For example, the language menu on this site (MDN) includes a <strong><code>lang</code></strong> attribute for each entry:</p>

<pre class="notranslate"> <code id="data">&lt;div class="dropdown-container language-menu"&gt;
	&lt;button id="header-language-menu" type="button" class="dropdown-menu-label" aria-haspopup="true" aria-owns="language-menu" aria-label="Current language is English. Choose your preferred language."&gt;English
		&lt;span class="dropdown-arrow-down" aria-hidden="true"&gt;▼&lt;/span&gt;
	&lt;/button&gt;
	&lt;ul id="language-menu" class="dropdown-menu-items right show" aria-expanded="true" role="menu"&gt;
		&lt;li lang="ca" role="menuitem"&gt;
			&lt;a href="/ca/docs/Web/HTML/Global_attributes/lang" title="Catalan"&gt;
				&lt;bdi&gt;Català&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="de" role="menuitem"&gt;
			&lt;a href="/de/docs/Web/HTML/Globale_Attribute/lang" title="German"&gt;
				&lt;bdi&gt;Deutsch&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="es" role="menuitem"&gt;
			&lt;a href="/es/docs/Web/HTML/Atributos_Globales/lang" title="Spanish"&gt;
				&lt;bdi&gt;Español&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="fr" role="menuitem"&gt;
			&lt;a href="/fr/docs/Web/HTML/Attributs_universels/lang" title="French"&gt;
				&lt;bdi&gt;Français&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="ja" role="menuitem"&gt;
			&lt;a href="/ja/docs/Web/HTML/Global_attributes/lang" title="Japanese"&gt;
				&lt;bdi&gt;日本語&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="ko" role="menuitem"&gt;
			&lt;a href="/ko/docs/Web/HTML/Global_attributes/lang" title="Korean"&gt;
				&lt;bdi&gt;한국어&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="pt-BR" role="menuitem"&gt;
			&lt;a href="/pt-BR/docs/Web/HTML/Global_attributes/lang" title="Portuguese (Brazilian)"&gt;
				&lt;bdi&gt;Português (do&amp;nbsp;Brasil)&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="ru" role="menuitem"&gt;
			&lt;a href="/ru/docs/Web/HTML/Global_attributes/lang" title="Russian"&gt;
				&lt;bdi&gt;Русский&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="uk" role="menuitem"&gt;
			&lt;a href="/uk/docs/Web/HTML/%D0%97%D0%B0%D0%B3%D0%B0%D0%BB%D1%8C%D0%BD%D1%96_%D0%B0%D1%82%D1%80%D0%B8%D0%B1%D1%83%D1%82%D0%B8/lang" title="Ukrainian"&gt;
				&lt;bdi&gt;Українська&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li lang="zh-CN" role="menuitem"&gt;
			&lt;a href="/zh-CN/docs/Web/HTML/Global_attributes/lang" title="Chinese (Simplified)"&gt;
				&lt;bdi&gt;中文 (简体)&lt;/bdi&gt;
			&lt;/a&gt;
		&lt;/li&gt;
		&lt;li&gt;
			&lt;a href="/en-US/docs/Web/HTML/Global_attributes/lang$locales" rel="nofollow" id="translations-add"&gt;Add a translation&lt;/a&gt;
		&lt;/li&gt;
	&lt;/ul&gt;
&lt;/div&gt;</code> </pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "dom.html#the-lang-and-xml:lang-attributes", "lang")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from latest snapshot, {{SpecName('HTML5.1')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', "dom.html#the-lang-and-xml:lang-attributes", "lang")}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}, no change from {{SpecName('HTML5 W3C')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "dom.html#the-lang-and-xml:lang-attributes", "lang")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Snapshot of {{SpecName('HTML WHATWG')}}, behavior with <code>xml:lang</code> and language determination algorithm defined. It also is a true global attribute.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML4.01', 'struct/dirlang.html#h-8.1', 'lang')}}</td>
   <td>{{Spec2('HTML4.01')}}</td>
   <td>Supported on all elements but {{HTMLElement("applet")}}, {{HTMLElement("base")}}, {{HTMLElement("basefont")}}, {{HTMLElement("br")}}, {{HTMLElement("frame")}}, {{HTMLElement("frameset")}}, {{HTMLElement("iframe")}}, {{HTMLElement("param")}}, and {{HTMLElement("script")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.global_attributes.lang")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>All <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</li>
 <li><a href="/en-US/docs/Web/HTTP/Headers/Content-Language"><code>Content-Language</code> HTTP Header</a></li>
 <li>HTML {{htmlattrxref("translate")}} attribute</li>
</ul>
